import sys
import math

n = len( sys.argv )
if n != 3:
	print "Args: x y"
	sys.exit(1)

a = 4
b = 2
x = float( sys.argv[1] ) 
y = float( sys.argv[2] ) 

b2 = b*b
a2 = a*a

# Valores iniciales:
vxk1 = [ x, y ]
v = a*b/math.sqrt(b2*x*x + a2*y*y)
vxk1[0] *= v
vxk1[1] *= v

vxk2 = [ 0.0, 0.0 ]
if math.fabs( x ) < a :
	vxk2[0] = x
	vxk2[1] = math.sqrt(a2-x*x)*b/a
	if y < 0:
		vxk2[1] = -vxk2[1] 
else :
	vxk2[0] = a
	if x <= 0 :
		vxk2[0] = -vxk2[0]

vx0 = [ (vxk1[0]+vxk2[0])/2.0, (vxk1[1]+vxk2[1])/2.0 ]

imax = 30

print "0", vx0

vxi = [0.0, 0.0]
vf = [0.0, 0.0]
Q = [ [0.0, 0.0], [0.0, 0.0] ];
Qi = [ [0.0, 0.0], [0.0, 0.0] ];
i=1
while i <= imax :
	Q[0][0] = b2*vx0[0]
	Q[0][1] = a2*vx0[1]
	Q[1][0] = (a2-b2)*vx0[1] + b2*y
	Q[1][1] = (a2-b2)*vx0[0] - a2*x

	d = Q[0][0]*Q[1][1] - Q[0][1]*Q[1][0]
	Qi[0][0] = Q[1][1]/d
	Qi[0][1] = -Q[0][1]/d
	Qi[1][0] = -Q[1][0]/d
	Qi[1][1] = Q[0][0]/d

	vf[0] = (a2*vx0[1]*vx0[1] + b2*vx0[0]*vx0[0] - a2*b2)/2.0
	vf[1] = b2*vx0[0]*(y - vx0[1]) - a2*vx0[1]*(x - vx0[0])

	vxi[0] = vx0[0] - Qi[0][0]*vf[0] - Qi[0][1]*vf[1]
	vxi[1] = vx0[1] - Qi[1][0]*vf[0] - Qi[1][1]*vf[1]

	print i, vxi

	vx = vxi[0] - vx0[0]
	vy = vxi[1] - vx0[1]
	v = vx*vx + vy*vy
	if v < 1e-12 :
		break

	vx0[0] = vxi[0]
	vx0[1] = vxi[1]

	i += 1
