# Function f from:
# L.G. de la Fraga, I. Vite Silva, and N. Cruz-Cortés,
# Euclidean distance fit of conics using differential evolution,
# Book Chapter in: Evolutionary Image Analysis and Signal Processing
# Studies in Computational Intelligence 2013,
# S. Gagnoni (Ed.)
# 2009, Springer 
#
set term x11
a = 4
b = 2

x = 2
y = 3

set xrange[0:2*pi]
set grid

f(t) = y*b*cos(t) - x*a*sin(t) + (a*a - b*b)*sin(t)*cos(t)
plot f(x)
pause -1

